## cog 0.12.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3)

list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
include(VersioningUtils)

set_project_version(0 12 0)

# Before making a release, the LT_VERSION string should be modified.
# The string is of the form C:R:A.
# - If interfaces have been changed or added, but binary compatibility has
#   been preserved, change to C+1:0:A+1
# - If binary compatibility has been broken (eg removed or changed interfaces)
#   change to C+1:0:0
# - If the interface is the same as the previous version, change to C:R+1:A
calculate_library_versions_from_libtool_triple(COGCORE 7 1 0)

project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
include(DistTargets)
include(GNUInstallDirs)

set(COG_VERSION_EXTRA "")
if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
    set(COG_VERSION_EXTRA "+git")
    find_package(Git)
    file(COPY ${CMAKE_SOURCE_DIR}/hooks/pre-commit DESTINATION ${CMAKE_SOURCE_DIR}/.git/hooks FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ)
    if (GIT_FOUND)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" rev-list --max-count=1 --abbrev-commit HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            RESULT_VARIABLE GIT_STATUS
            OUTPUT_VARIABLE GIT_OUTPUT
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_QUIET)
        if (${GIT_STATUS} EQUAL 0 AND GIT_OUTPUT)
            set(COG_VERSION_EXTRA "${COG_VERSION_EXTRA}-${GIT_OUTPUT}")
        endif ()
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" status --porcelain
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            RESULT_VARIABLE GIT_STATUS
            OUTPUT_VARIABLE GIT_OUTPUT
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_QUIET)
        if (${GIT_STATUS} EQUAL 0 AND GIT_OUTPUT)
            set(COG_VERSION_EXTRA "${COG_VERSION_EXTRA}-dirty")
        endif ()
        unset(GIT_STATUS)
        unset(GIT_OUTPUT)
    endif ()
    message(STATUS "Source tree revision: ${PROJECT_VERSION}${COG_VERSION_EXTRA}")
endif ()



option(COG_DBUS_SYSTEM_BUS "Expose remote control interface on system bus" OFF)
set(COG_DBUS_OWN_USER "" CACHE STRING
    "Additional user allowed to own the well-known name on the system bus")

option(COG_PLATFORM_HEADLESS "Build the headless platform module" ON)
option(COG_PLATFORM_WL "Build the Wayland platform module" ON)
option(COG_PLATFORM_DRM "Build the DRM platform module" ON)
option(COG_PLATFORM_X11 "Build the X11 platform module" OFF)
option(COG_PLATFORM_GTK4 "Build the GTK4 platform module" OFF)

option(COG_BUILD_PROGRAMS "Build and install programs as well" ON)
option(INSTALL_MAN_PAGES "Install the man(1) pages if COG_BUILD_PROGRAMS is enabled" ON)
option(COG_WESTON_DIRECT_DISPLAY "Build direct display support for the Wayland platform module" OFF)
option(BUILD_DOCS "Build the documentation" OFF)

option(USE_SOUP2 "Build with libsoup2 instead of libsoup3" ON)

set(COG_APPID "" CACHE STRING "Default GApplication unique identifier")
set(COG_HOME_URI "" CACHE STRING "Default home URI")

set(COG_MODULEDIR "${CMAKE_INSTALL_PREFIX}/lib/cog/modules"
    CACHE STRING "Default search path for loadable modules")

if (NOT COG_APPID OR COG_APPID STREQUAL "")
    set(COG_DEFAULT_APPID com.igalia.Cog)
else ()
    set(COG_DEFAULT_APPID ${COG_APPID})
endif ()

if (COG_HOME_URI AND NOT COG_HOME_URI STREQUAL "")
    set(COG_DEFAULT_HOME_URI ${COG_HOME_URI})
endif ()

if (BUILD_SHARED_LIBS)
    set(COGCORE_COMPONENT "runtime")
else()
    set(COGCORE_COMPONENT "development")
endif()

add_definitions(-DCOG_INSIDE_COG__=1)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(PkgConfig)

# libcogcore
set(COGCORE_API_HEADERS
    core/cog.h
    core/cog-launcher.h
    core/cog-request-handler.h
    core/cog-directory-files-handler.h
    core/cog-host-routes-handler.h
    core/cog-prefix-routes-handler.h
    core/cog-shell.h
    core/cog-utils.h
    core/cog-webkit-utils.h
    core/cog-platform.h
    core/cog-modules.h
    core/cog-modules.c
    ${CMAKE_CURRENT_BINARY_DIR}/cog-config.h
)
set(COGCORE_SOURCES
    core/cog-launcher.c
    core/cog-request-handler.c
    core/cog-directory-files-handler.c
    core/cog-host-routes-handler.c
    core/cog-prefix-routes-handler.c
    core/cog-utils.c
    core/cog-shell.c
    core/cog-webkit-utils.c
    core/cog-platform.c
)

if (USE_SOUP2)
    set(WPEWEBKIT_PC_NAME "wpe-webkit-1.0")
    set(REQUIRED_GIO_VERSION "gio-2.0>=2.44")
    set(REQUIRED_SOUP_VERSION "libsoup-2.4")
    set(REQUIRED_WEBKIT_VERSION "wpe-webkit-1.0>=2.28.0")
    add_definitions("-DCOG_USE_SOUP2=1")
else()
    set(WPEWEBKIT_PC_NAME "wpe-webkit-1.1")
    set(REQUIRED_GIO_VERSION "gio-2.0>=2.67.4")
    set(REQUIRED_SOUP_VERSION "libsoup-3.0>=2.99.7")
    set(REQUIRED_WEBKIT_VERSION "wpe-webkit-1.1>=2.33.1")
    add_definitions("-DCOG_USE_SOUP2=0")
endif()

pkg_check_modules(GIO IMPORTED_TARGET REQUIRED ${REQUIRED_GIO_VERSION})
pkg_check_modules(SOUP IMPORTED_TARGET REQUIRED ${REQUIRED_SOUP_VERSION})
pkg_check_modules(WebKit IMPORTED_TARGET REQUIRED ${REQUIRED_WEBKIT_VERSION})

include(CheckCCompilerFlag)
check_c_compiler_flag(-Wall HAS_WALL)

if (COG_DBUS_SYSTEM_BUS)
    # Generate and install D-Bus policy configuration file.
    configure_file(dbus/policy.conf.in ${COG_DEFAULT_APPID}.conf @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${COG_DEFAULT_APPID}.conf
        DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/system.d
        COMPONENT "runtime"
    )

    # Let the source code know that the option is enabled.
    add_definitions(-DCOG_DBUS_SYSTEM_BUS=1)
    add_definitions(-DCOG_DBUS_OWN_USER=\"${COG_DBUS_OWN_USER}\")
endif ()

add_library(cogcore SHARED ${COGCORE_SOURCES} ${COGCORE_API_HEADERS})
set_target_properties(cogcore PROPERTIES
    C_STANDARD 99
    VERSION ${COGCORE_VERSION}
    SOVERSION ${COGCORE_VERSION_MAJOR}
)
target_link_libraries(cogcore PkgConfig::GIO PkgConfig::WebKit PkgConfig::SOUP)
target_compile_definitions(cogcore PRIVATE G_LOG_DOMAIN=\"Cog-Core\")
if (HAS_WALL)
    target_compile_options(cogcore PUBLIC -Wall)
endif ()

if (COG_BUILD_PROGRAMS)
    add_executable(cog cog.c)
    set_property(TARGET cog PROPERTY C_STANDARD 99)
    if (HAS_WALL)
      target_compile_options(cog PUBLIC "-Wall")
    endif ()
    target_compile_definitions(cog PRIVATE G_LOG_DOMAIN=\"Cog\")
    target_link_libraries(cog cogcore -ldl)

    add_executable(cogctl cogctl.c core/cog-utils.c)
    set_property(TARGET cogctl PROPERTY C_STANDARD 99)
    target_compile_definitions(cogctl PRIVATE G_LOG_DOMAIN=\"Cog-Control\")
    if (HAS_WALL)
      target_compile_options(cogctl PUBLIC "-Wall")
    endif ()
    target_link_libraries(cogctl PkgConfig::GIO PkgConfig::SOUP)

    install(TARGETS cog cogctl
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT "runtime"
    )
    if (INSTALL_MAN_PAGES)
        install(FILES data/cog.1 data/cogctl.1
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
            COMPONENT "runtime"
        )
    endif ()
endif ()


install(TARGETS cogcore
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT ${COGCORE_COMPONENT}
)
install(FILES ${COGCORE_API_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cog
    COMPONENT "development"
)

configure_file(core/cog-config.h.in cog-config.h @ONLY)
configure_file(core/cogcore.pc.in cogcore.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cogcore.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT "development"
)

if (BUILD_DOCS)
    add_subdirectory(docs)
endif ()

if (COG_PLATFORM_HEADLESS)
    add_subdirectory(platform/headless)
endif ()
if (COG_PLATFORM_WL)
    add_subdirectory(platform/wayland)
endif ()
if (COG_PLATFORM_DRM)
    add_subdirectory(platform/drm)
endif ()
if (COG_PLATFORM_X11)
    add_subdirectory(platform/x11)
endif ()
if (COG_PLATFORM_GTK4)
    add_subdirectory(platform/gtk4)
endif ()

=== debian/changelog ===
cog (0.12.0-2) unstable; urgency=medium

  * debian/patches/fix-moduledir.patch:
    - This patch was broken, fix applying upstream commit 64effa9.

 -- Alberto Garcia <berto@igalia.com>  Fri, 04 Feb 2022 00:20:24 +0100

cog (0.12.0-1) unstable; urgency=medium

  * New upstream release.
  * Install modules in multiarch-compliant path:
    - debian/patches/fix-moduledir.patch: Fix path definition.
    - debian/install: Update installation rules.
  * debian/cog.lintian-overrides:
    - Update overrides.
  * debian/control:
    - Update Standards-Version to 4.6.0.1 (no changes).

 -- Alberto Garcia <berto@igalia.com>  Wed, 24 Nov 2021 21:57:03 +0100

## cog 0.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
 include(VersioningUtils)
 
-set_project_version(0 12 0)
+set_project_version(0 12 1)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -12,7 +12,7 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 7 1 0)
+calculate_library_versions_from_libtool_triple(COGCORE 7 2 0)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
 include(DistTargets)
@@ -72,7 +72,7 @@
 set(COG_APPID "" CACHE STRING "Default GApplication unique identifier")
 set(COG_HOME_URI "" CACHE STRING "Default home URI")
 
-set(COG_MODULEDIR "${CMAKE_INSTALL_PREFIX}/lib/cog/modules"
+set(COG_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/cog/modules"
     CACHE STRING "Default search path for loadable modules")
 
 if (NOT COG_APPID OR COG_APPID STREQUAL "")

=== docs/CMakeLists.txt ===
find_package(GObjectIntrospection REQUIRED)
find_program(GI_DOCGEN
    NAMES gi-docgen gi-docgen.py
    HINTS "${CMAKE_SOURCE_DIR}/gi-docgen"
    DOC "Path to the gi-docgen program"
    REQUIRED
)

message(STATUS "Using g-ir-scanner: ${INTROSPECTION_SCANNER}")
message(STATUS "Using gi-docgen: ${GI_DOCGEN}")

configure_file(cog.toml.in cog.toml @ONLY)

# TODO: Probably should be moved somewhere else, and use the API
#       version string for other things, e.g. the library name.
set(COGCORE_API_VERSION "${PROJECT_VERSION_MAJOR}.0")
set(COGCORE_GIR_NAME "Cog-${COGCORE_API_VERSION}")
set(COGCORE_GIR "${CMAKE_CURRENT_BINARY_DIR}/${COGCORE_GIR_NAME}.gir")

function (get_target_doc_sources target varname)
    set(result "")
    get_property(sources TARGET ${target} PROPERTY SOURCES)
    get_property(srcdir TARGET ${target} PROPERTY SOURCE_DIR)
    foreach (src IN LISTS sources)
        get_filename_component(src "${src}" REALPATH BASE_DIR "${srcdir}")
        get_property(isobject SOURCE "${src}" PROPERTY EXTERNAL_OBJECT)
        get_property(location SOURCE "${src}" PROPERTY LOCATION)
        if (NOT isobject)
            list(APPEND result "${location}")
        endif ()
    endforeach ()
    set(${varname} ${result} PARENT_SCOPE)
endfunction ()

function (get_target_include_flags target varname)
    set(result "")
    get_property(dirs TARGET ${target} PROPERTY INCLUDE_DIRECTORIES)
    foreach (dir IN LISTS dirs)
        list(APPEND result "-I${dir}")
    endforeach ()
    set(${varname} ${result} PARENT_SCOPE)
endfunction ()

get_target_doc_sources(cogcore COGCORE_DOC_SOURCES)
get_target_include_flags(cogcore COGCORE_DOC_IFLAGS)

add_custom_command(
    OUTPUT "${COGCORE_GIR}"
    COMMENT "Generating ${COGCORE_GIR_NAME}.gir ..."
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    DEPENDS ${COGCORE_DOC_SOURCES}
    VERBATIM
    COMMAND CC="${CMAKE_C_COMPILER}"
        ${INTROSPECTION_SCANNER}
        --output=${COGCORE_GIR}
        --warn-all
        --no-libtool
        --library=$<TARGET_FILE_BASE_NAME:cogcore>
        --library-path=$<TARGET_FILE_DIR:cogcore>
        --nsversion=${COGCORE_API_VERSION}
        --c-include=cog/cog.h
        --namespace=Cog
        --identifier-prefix=Cog
        --symbol-prefix=cog
        --pkg-export=cogcore
        --pkg=${WPEWEBKIT_PC_NAME}
        --pkg=gobject-2.0
        --pkg=gio-2.0
        --pkg=glib-2.0
        ${COGCORE_DOC_IFLAGS}
        ${COGCORE_DOC_SOURCES}
)

file(GLOB COGCORE_DOC_MARKDOWN_SOURCES *.md)

add_custom_command(
    OUTPUT html/index.html
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    COMMENT "Generating documentation for ${COGCORE_GIR_NAME} ..."
    DEPENDS cog.toml ${COGCORE_GIR} ${COGCORE_DOC_MARKDOWN_SOURCES}
    VERBATIM
    COMMAND "${GI_DOCGEN}" generate --quiet --no-namespace-dir
        --content-dir ${CMAKE_CURRENT_SOURCE_DIR}
        --output-dir ${CMAKE_CURRENT_BINARY_DIR}/html
        --config ${CMAKE_CURRENT_BINARY_DIR}/cog.toml
        ${COGCORE_GIR}
)

add_custom_target(doc ALL DEPENDS html/index.html)

=== platform/drm/CMakeLists.txt ===
# libcogplatform-drm

pkg_check_modules(EGL IMPORTED_TARGET REQUIRED egl)
pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.4.0)
pkg_check_modules(LibDRM IMPORTED_TARGET REQUIRED libdrm>=2.4.71)
pkg_check_modules(LibGBM IMPORTED_TARGET REQUIRED gbm>=13.0)
pkg_check_modules(LibInput IMPORTED_TARGET REQUIRED libinput)
pkg_check_modules(LibUdev IMPORTED_TARGET REQUIRED libudev)
pkg_check_modules(WaylandServer IMPORTED_TARGET REQUIRED wayland-server)

add_library(cogplatform-drm MODULE
    cog-platform-drm.c
    kms.c
    cursor-drm.c
)
set_target_properties(cogplatform-drm PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)
target_link_libraries(cogplatform-drm PRIVATE
    cogcore
    PkgConfig::EGL
    PkgConfig::LibDRM
    PkgConfig::LibGBM
    PkgConfig::LibInput
    PkgConfig::LibUdev
    PkgConfig::WaylandServer
    PkgConfig::WebKit
    PkgConfig::WpeFDO
)

string(REGEX MATCH "^([0-9]+)\.([0-9]+)\.([0-9]+)" _ "${LibInput_VERSION}")
target_compile_definitions(cogplatform-drm PRIVATE
    G_LOG_DOMAIN=\"Cog-DRM\"
    LIBINPUT_VER_MAJOR=${CMAKE_MATCH_1}
    LIBINPUT_VER_MINOR=${CMAKE_MATCH_2}
    LIBINPUT_VER_MICRO=${CMAKE_MATCH_3}
)

install(TARGETS cogplatform-drm
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime"
)

=== platform/gtk4/CMakeLists.txt ===
pkg_check_modules(COGPLATFORM_GTK4_DEPS REQUIRED
    IMPORTED_TARGET gtk4 wpebackend-fdo-1.0)
add_library(cogplatform-gtk4 MODULE
    cog-platform-gtk4.c
    cog-gtk-settings-dialog.c
    cog-gtk-settings-cell-renderer-variant.c)
target_link_libraries(cogplatform-gtk4 PRIVATE
    PkgConfig::COGPLATFORM_GTK4_DEPS
    PkgConfig::WebKit
)
set_target_properties(cogplatform-gtk4 PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)
target_compile_options(cogplatform-gtk4
    PRIVATE -DG_LOG_DOMAIN=\"Cog-Gtk4\")
install(TARGETS cogplatform-gtk4
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime")

=== platform/headless/CMakeLists.txt ===

pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.8.0)
add_library(cogplatform-headless MODULE cog-platform-headless.c)
set_target_properties(cogplatform-headless PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)

target_compile_definitions(cogplatform-headless PRIVATE G_LOG_DOMAIN=\"Cog-HEADLESS\")
target_link_libraries(cogplatform-headless PRIVATE
    cogcore
    PkgConfig::WpeFDO
)

install(TARGETS cogplatform-headless
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime"
)

=== platform/wayland/CMakeLists.txt ===
# libcogplatform-wl

add_library(cogplatform-wl MODULE
    cog-im-context-wl-v1.c
    cog-im-context-wl.c
    cog-platform-wl.c
    cog-popup-menu-wl.c
    os-compatibility.c
)
set_target_properties(cogplatform-wl PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)
target_compile_definitions(cogplatform-wl PRIVATE G_LOG_DOMAIN=\"Cog-FDO\")

find_package(WaylandProtocols REQUIRED)
add_wayland_protocol(cogplatform-wl CLIENT fullscreen-shell-unstable-v1)
add_wayland_protocol(cogplatform-wl CLIENT linux-dmabuf-unstable-v1)
add_wayland_protocol(cogplatform-wl CLIENT presentation-time)
add_wayland_protocol(cogplatform-wl CLIENT text-input-unstable-v1)
add_wayland_protocol(cogplatform-wl CLIENT text-input-unstable-v3)
add_wayland_protocol(cogplatform-wl CLIENT xdg-shell)

pkg_check_modules(Cairo IMPORTED_TARGET cairo)
pkg_check_modules(EGL IMPORTED_TARGET REQUIRED egl)
pkg_check_modules(WAYLAND IMPORTED_TARGET REQUIRED wayland-client)
pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.6.0)
pkg_check_modules(XkbCommon IMPORTED_TARGET REQUIRED xkbcommon)

target_link_libraries(cogplatform-wl PRIVATE
    cogcore
    PkgConfig::Cairo
    PkgConfig::EGL
    PkgConfig::WAYLAND
    PkgConfig::WebKit
    PkgConfig::WpeFDO
)


pkg_check_modules(WAYLAND_EGL IMPORTED_TARGET wayland-egl)
if (TARGET PkgConfig::WAYLAND_EGL)
    target_link_libraries(cogplatform-wl PRIVATE PkgConfig::WAYLAND_EGL)
endif ()

install(TARGETS cogplatform-wl
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime"
)

if (COG_WESTON_DIRECT_DISPLAY)

    # Direct video display extension.
    find_path(WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT
        NAMES wpe/extensions/video-plane-display-dmabuf.h
        PATHS ${WpeFDO_INCLUDE_DIRS}
        NO_DEFAULT_PATH
        REQUIRED
    )

    pkg_check_modules(LIBWESTON REQUIRED libweston-9-protocols)
    pkg_get_variable(LIBWESTON_PKG_DATA_DIR libweston-9-protocols "pkgdatadir")
    add_wayland_protocol(cogplatform-wl CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-direct-display.xml")
    add_wayland_protocol(cogplatform-wl CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-content-protection.xml")
    target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=1)
else ()
    target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=0)
endif ()

# Optional pointer support
pkg_check_modules(WaylandCursor IMPORTED_TARGET wayland-cursor)
if (TARGET PkgConfig::WaylandCursor)
    target_compile_definitions(cogplatform-wl PRIVATE COG_USE_WAYLAND_CURSOR)
    target_link_libraries(cogplatform-wl PRIVATE PkgConfig::WaylandCursor)
endif ()

=== platform/x11/CMakeLists.txt ===
# libcogplaform-x11

pkg_check_modules(COGPLATFORM_X11_DEPS IMPORTED_TARGET
    REQUIRED wpebackend-fdo-1.0>=1.6.0 egl xcb xkbcommon-x11)

add_library(cogplatform-x11 MODULE cog-platform-x11.c)
set_target_properties(cogplatform-x11 PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)
target_compile_definitions(cogplatform-x11 PRIVATE G_LOG_DOMAIN=\"Cog-X11\")
target_link_libraries(cogplatform-x11 PRIVATE cogcore
    PkgConfig::COGPLATFORM_X11_DEPS
    PkgConfig::WebKit
)

install(TARGETS cogplatform-x11
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime"
)

=== debian/changelog ===
cog (0.12.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop debian/patches/fix-moduledir.patch.
  * debian/watch:
    - Scan for stable releases only.
  * debian/copyright:
    - Update copyright years.

 -- Alberto Garcia <berto@igalia.com>  Fri, 25 Feb 2022 00:37:38 +0100

=== debian/control ===
Source: cog
Section: web
Priority: optional
Maintainer: Alberto Garcia <berto@igalia.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libcairo-dev,
               libdrm-dev,
               libgbm-dev,
               libinput-dev,
               libwayland-dev,
               libwpebackend-fdo-1.0-dev (>= 1.10.0),
               libwpewebkit-1.0-dev,
               wayland-protocols
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://github.com/Igalia/cog
Vcs-Browser: https://salsa.debian.org/berto/cog
Vcs-Git: https://salsa.debian.org/berto/cog.git

Package: cog
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Single-window web browser based on WPE WebKit
 Cog is a small, single-window web browser based on WPE WebKit.
 It provides no user interface and is suitable to be used as a web
 application container for embedded devices in kiosk mode.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://wpewebkit.org/releases/ cog-([\d]+\.[\d]*[02468]\.[\d]+).tar.xz

## cog 0.12.4

=== debian/changelog ===
cog (0.12.4-1) unstable; urgency=medium

  * New upstream release.
  * Switch from libsoup2 to libsoup3:
    - debian/control: change build dependency to libwpewebkit-1.1-dev.
    - debian/rules: build with -DUSE_SOUP2=OFF.

 -- Alberto Garcia <berto@igalia.com>  Tue, 05 Apr 2022 10:16:34 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libinput-dev,
                libwayland-dev,
                libwpebackend-fdo-1.0-dev (>= 1.10.0),
-               libwpewebkit-1.0-dev,
+               libwpewebkit-1.1-dev,
                wayland-protocols
 Standards-Version: 4.6.0.1
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SOUP2=OFF

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## cog 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-cmake_minimum_required (VERSION 3.3)
+cmake_minimum_required (VERSION 3.12)
 
 list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
 include(VersioningUtils)
 
-set_project_version(0 12 1)
+set_project_version(0 14 0)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -12,11 +12,13 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 7 2 0)
+calculate_library_versions_from_libtool_triple(COGCORE 9 4 0)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
+include(CMakeDependentOption)
 include(DistTargets)
 include(GNUInstallDirs)
+include(JoinPaths)
 
 set(COG_VERSION_EXTRA "")
 if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
@@ -65,15 +67,28 @@
 option(COG_BUILD_PROGRAMS "Build and install programs as well" ON)
 option(INSTALL_MAN_PAGES "Install the man(1) pages if COG_BUILD_PROGRAMS is enabled" ON)
 option(COG_WESTON_DIRECT_DISPLAY "Build direct display support for the Wayland platform module" OFF)
+cmake_dependent_option(COG_WESTON_CONTENT_PROTECTION "Build direct content protection for the Wayland platform module" OFF "COG_WESTON_DIRECT_DISPLAY" OFF)
 option(BUILD_DOCS "Build the documentation" OFF)
 
-option(USE_SOUP2 "Build with libsoup2 instead of libsoup3" ON)
+option(USE_SOUP2 "Build with libsoup2 instead of libsoup3" OFF)
 
 set(COG_APPID "" CACHE STRING "Default GApplication unique identifier")
 set(COG_HOME_URI "" CACHE STRING "Default home URI")
 
 set(COG_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/cog/modules"
-    CACHE STRING "Default search path for loadable modules")
+    CACHE PATH "Default search path for loadable modules")
+
+# Make sure that the module path is always absolute. If the specified
+# value is relative, this makes it a child of CMAKE_INSTALL_PREFIX.
+if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.20)
+    cmake_path(ABSOLUTE_PATH COG_MODULEDIR BASE_DIRECTORY ${CMAKE_INSTALL_PREFIX} NORMALIZE)
+elseif (NOT IS_ABSOLUTE ${COG_MODULEDIR})
+    set(COG_MODULEDIR "${CMAKE_INSTALL_PREFIX}/${COG_MODULEDIR}")
+endif ()
+if (NOT IS_ABSOLUTE ${COG_MODULEDIR})
+    message(FATAL_ERROR "Cog module location '${COG_MODULEDIR}' is not an absolute path")
+endif ()
+message(STATUS "Cog module path: ${COG_MODULEDIR}")
 
 if (NOT COG_APPID OR COG_APPID STREQUAL "")
     set(COG_DEFAULT_APPID com.igalia.Cog)
@@ -100,7 +115,6 @@
 # libcogcore
 set(COGCORE_API_HEADERS
     core/cog.h
-    core/cog-launcher.h
     core/cog-request-handler.h
     core/cog-directory-files-handler.h
     core/cog-host-routes-handler.h
@@ -114,7 +128,6 @@
     ${CMAKE_CURRENT_BINARY_DIR}/cog-config.h
 )
 set(COGCORE_SOURCES
-    core/cog-launcher.c
     core/cog-request-handler.c
     core/cog-directory-files-handler.c
     core/cog-host-routes-handler.c
@@ -143,6 +156,12 @@
 pkg_check_modules(SOUP IMPORTED_TARGET REQUIRED ${REQUIRED_SOUP_VERSION})
 pkg_check_modules(WebKit IMPORTED_TARGET REQUIRED ${REQUIRED_WEBKIT_VERSION})
 
+if (WebKit_VERSION VERSION_GREATER_EQUAL 2.34.0)
+    set(HAVE_WEBKIT_MEM_PRESSURE_API 1)
+else()
+    set(HAVE_WEBKIT_MEM_PRESSURE_API 0)
+endif()
+
 include(CheckCCompilerFlag)
 check_c_compiler_flag(-Wall HAS_WALL)
 
@@ -173,32 +192,7 @@
 endif ()
 
 if (COG_BUILD_PROGRAMS)
-    add_executable(cog cog.c)
-    set_property(TARGET cog PROPERTY C_STANDARD 99)
-    if (HAS_WALL)
-      target_compile_options(cog PUBLIC "-Wall")
-    endif ()
-    target_compile_definitions(cog PRIVATE G_LOG_DOMAIN=\"Cog\")
-    target_link_libraries(cog cogcore -ldl)
-
-    add_executable(cogctl cogctl.c core/cog-utils.c)
-    set_property(TARGET cogctl PROPERTY C_STANDARD 99)
-    target_compile_definitions(cogctl PRIVATE G_LOG_DOMAIN=\"Cog-Control\")
-    if (HAS_WALL)
-      target_compile_options(cogctl PUBLIC "-Wall")
-    endif ()
-    target_link_libraries(cogctl PkgConfig::GIO PkgConfig::SOUP)
-
-    install(TARGETS cog cogctl
-        DESTINATION ${CMAKE_INSTALL_BINDIR}
-        COMPONENT "runtime"
-    )
-    if (INSTALL_MAN_PAGES)
-        install(FILES data/cog.1 data/cogctl.1
-            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
-            COMPONENT "runtime"
-        )
-    endif ()
+    add_subdirectory(launcher)
 endif ()
 
 
@@ -210,6 +204,9 @@
     DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cog
     COMPONENT "development"
 )
+
+join_paths(COG_PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(COG_PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
 
 configure_file(core/cog-config.h.in cog-config.h @ONLY)
 configure_file(core/cogcore.pc.in cogcore.pc @ONLY)

=== launcher/CMakeLists.txt ===
add_executable(cog
    cog.c
    cog-launcher.c
)
set_target_properties(cog PROPERTIES
    C_STANDARD 99
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)
target_compile_definitions(cog PRIVATE G_LOG_DOMAIN=\"Cog\")
target_link_libraries(cog cogcore -ldl)

add_executable(cogctl
    cogctl.c
    ../core/cog-utils.c
)
set_target_properties(cogctl PROPERTIES
    C_STANDARD 99
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)
target_compile_definitions(cogctl PRIVATE G_LOG_DOMAIN=\"Cog-Control\")
target_link_libraries(cogctl PkgConfig::GIO PkgConfig::SOUP)

if (HAS_WALL)
    target_compile_options(cog PUBLIC "-Wall")
    target_compile_options(cogctl PUBLIC "-Wall")
endif ()

install(TARGETS cog cogctl
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT "runtime"
)
if (INSTALL_MAN_PAGES)
    install(FILES ../data/cog.1 ../data/cogctl.1
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
        COMPONENT "runtime"
    )
endif ()

=== platform/drm/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,19 @@
 # libcogplatform-drm
 
-pkg_check_modules(EGL IMPORTED_TARGET REQUIRED egl)
-pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.4.0)
+pkg_check_modules(Epoxy IMPORTED_TARGET REQUIRED epoxy)
 pkg_check_modules(LibDRM IMPORTED_TARGET REQUIRED libdrm>=2.4.71)
 pkg_check_modules(LibGBM IMPORTED_TARGET REQUIRED gbm>=13.0)
 pkg_check_modules(LibInput IMPORTED_TARGET REQUIRED libinput)
 pkg_check_modules(LibUdev IMPORTED_TARGET REQUIRED libudev)
 pkg_check_modules(WaylandServer IMPORTED_TARGET REQUIRED wayland-server)
+find_package(WpeFDO REQUIRED)
 
 add_library(cogplatform-drm MODULE
+    ../common/cog-gl-utils.c
     cog-platform-drm.c
+    cog-drm-renderer.c
+    cog-drm-gles-renderer.c
+    cog-drm-modeset-renderer.c
     kms.c
     cursor-drm.c
 )
@@ -19,14 +23,14 @@
 )
 target_link_libraries(cogplatform-drm PRIVATE
     cogcore
-    PkgConfig::EGL
+    PkgConfig::Epoxy
     PkgConfig::LibDRM
     PkgConfig::LibGBM
     PkgConfig::LibInput
     PkgConfig::LibUdev
     PkgConfig::WaylandServer
     PkgConfig::WebKit
-    PkgConfig::WpeFDO
+    Wpe::FDO
 )
 
 string(REGEX MATCH "^([0-9]+)\.([0-9]+)\.([0-9]+)" _ "${LibInput_VERSION}")

=== platform/gtk4/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,16 @@
 pkg_check_modules(COGPLATFORM_GTK4_DEPS REQUIRED
-    IMPORTED_TARGET gtk4 wpebackend-fdo-1.0)
+    IMPORTED_TARGET gtk4)
+find_package(WpeFDO REQUIRED)
+
 add_library(cogplatform-gtk4 MODULE
+    ../common/cog-gl-utils.c
     cog-platform-gtk4.c
     cog-gtk-settings-dialog.c
     cog-gtk-settings-cell-renderer-variant.c)
 target_link_libraries(cogplatform-gtk4 PRIVATE
     PkgConfig::COGPLATFORM_GTK4_DEPS
     PkgConfig::WebKit
+    Wpe::FDO
 )
 set_target_properties(cogplatform-gtk4 PROPERTIES
     LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules

=== platform/headless/CMakeLists.txt ===
find_package(WpeFDO REQUIRED)

add_library(cogplatform-headless MODULE cog-platform-headless.c)
set_target_properties(cogplatform-headless PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)

target_compile_definitions(cogplatform-headless PRIVATE G_LOG_DOMAIN=\"Cog-HEADLESS\")
target_link_libraries(cogplatform-headless PRIVATE
    cogcore
    Wpe::FDO
)

install(TARGETS cogplatform-headless
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime"
)

=== platform/wayland/CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,8 @@
 pkg_check_modules(Cairo IMPORTED_TARGET cairo)
 pkg_check_modules(EGL IMPORTED_TARGET REQUIRED egl)
 pkg_check_modules(WAYLAND IMPORTED_TARGET REQUIRED wayland-client)
-pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.6.0)
 pkg_check_modules(XkbCommon IMPORTED_TARGET REQUIRED xkbcommon)
+find_package(WpeFDO REQUIRED)
 
 target_link_libraries(cogplatform-wl PRIVATE
     cogcore
@@ -33,9 +33,8 @@
     PkgConfig::EGL
     PkgConfig::WAYLAND
     PkgConfig::WebKit
-    PkgConfig::WpeFDO
+    Wpe::FDO
 )
-
 
 pkg_check_modules(WAYLAND_EGL IMPORTED_TARGET wayland-egl)
 if (TARGET PkgConfig::WAYLAND_EGL)
@@ -57,13 +56,19 @@
         REQUIRED
     )
 
-    pkg_check_modules(LIBWESTON REQUIRED libweston-9-protocols)
-    pkg_get_variable(LIBWESTON_PKG_DATA_DIR libweston-9-protocols "pkgdatadir")
+    pkg_search_module(LIBWESTON REQUIRED libweston-11-protocols libweston-10-protocols libweston-9-protocols libweston-8-protocols)
+    pkg_get_variable(LIBWESTON_PKG_DATA_DIR ${LIBWESTON_MODULE_NAME} "pkgdatadir")
     add_wayland_protocol(cogplatform-wl CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-direct-display.xml")
-    add_wayland_protocol(cogplatform-wl CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-content-protection.xml")
     target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=1)
+    if (COG_WESTON_CONTENT_PROTECTION)
+        add_wayland_protocol(cogplatform-wl CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-content-protection.xml")
+        target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_CONTENT_PROTECTION=1)
+    else ()
+        target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_CONTENT_PROTECTION=0)
+    endif ()
 else ()
     target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=0)
+    target_compile_definitions(cogplatform-wl PRIVATE COG_ENABLE_WESTON_CONTENT_PROTECTION=0)
 endif ()
 
 # Optional pointer support

=== platform/x11/CMakeLists.txt ===
# libcogplaform-x11

pkg_check_modules(Epoxy IMPORTED_TARGET REQUIRED epoxy)
pkg_check_modules(COGPLATFORM_X11_DEPS IMPORTED_TARGET
    REQUIRED egl xcb xkbcommon-x11 x11-xcb)
find_package(WpeFDO REQUIRED)

add_library(cogplatform-x11 MODULE
    ../common/cog-gl-utils.c
    cog-platform-x11.c
)
set_target_properties(cogplatform-x11 PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/modules
)
target_compile_definitions(cogplatform-x11 PRIVATE G_LOG_DOMAIN=\"Cog-X11\")
target_link_libraries(cogplatform-x11 PRIVATE cogcore
    PkgConfig::Epoxy
    PkgConfig::COGPLATFORM_X11_DEPS
    PkgConfig::WebKit
    Wpe::FDO
)

install(TARGETS cogplatform-x11
    DESTINATION ${COG_MODULEDIR}
    COMPONENT "runtime"
)

=== debian/changelog ===
cog (0.14.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/cog.lintian-overrides:
    - Update overrides.
    - Add no-symbols-control-file override.
  * debian/control:
    - Set the debhelper compatibility level to 13.
    - Update Standards-Version to 4.6.1.0.

 -- Alberto Garcia <berto@igalia.com>  Wed, 24 Aug 2022 15:34:44 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: web
 Priority: optional
 Maintainer: Alberto Garcia <berto@igalia.com>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libcairo-dev,
                libdrm-dev,
@@ -12,7 +12,7 @@
                libwpebackend-fdo-1.0-dev (>= 1.10.0),
                libwpewebkit-1.1-dev,
                wayland-protocols
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Rules-Requires-Root: no
 Homepage: https://github.com/Igalia/cog
 Vcs-Browser: https://salsa.debian.org/berto/cog

## cog 0.16.0

=== debian/changelog ===
cog (0.16.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Remove obsolete files.
  * debian/control:
    - Replace build dependency on cmake with meson.
    - Add build dependency on libmanette-0.2-dev.
  * debian/rules:
    - Stop building with -DUSE_SOUP2=OFF, this is no longer necessary.

 -- Alberto Garcia <berto@igalia.com>  Tue, 27 Sep 2022 15:04:18 +0200

## cog 0.16.1

=== meson_options.txt ===
option(
    'plugin_path',
    type: 'string',
    description: 'Default installation path for loadable plug-ins'
)
option(
    'platforms',
    type: 'array',
    value: ['drm', 'headless', 'wayland'],
    choices: ['drm', 'headless', 'wayland', 'gtk4', 'x11'],
    description: 'platform plug-ins to build'
)
option(
    'programs',
    type: 'boolean',
    value: true,
    description: 'build and install programs (cog, cogctl)'
)
option(
    'soup2',
    type: 'feature',
    value: 'auto',
    description: 'Build with libsoup2 instead of libsoup3'
)

# Wayland platform-specific features
option(
    'wayland_weston_direct_display',
    type: 'boolean',
    value: false,
    description: 'Build direct-display support in the Wayland platform plug-in'
)
option(
    'wayland_weston_content_protection',
    type: 'boolean',
    value: false,
    description: 'Build content-protection support in the Wayland platform plug-in'
)

# Additional cog/cogctl options
option(
    'cog_appid',
    type: 'string',
    value: 'com.igalia.Cog',
    description: 'Default GApplication unique identifier for Cog'
)
option(
    'cog_home_uri',
    type: 'string',
    description: 'Default home URI loaded by Cog at startup'
)
option(
    'cog_dbus_control',
    type: 'combo',
    value: 'user',
    choices: ['user', 'system'],
    description: 'Bus on which to expose the Cog remote control interface'
)
option(
    'cog_dbus_system_owner',
    type: 'string',
    value: '',
    description: 'Additional user allowed to own the well-known name on the system bus'
)

# Documentation
option(
    'documentation',
    type: 'boolean',
    value: false,
    description: 'Build the documentation'
)
option(
    'manpages',
    type: 'boolean',
    value: true,
    description: 'Install man(1) pages for built programs'
)

=== debian/changelog ===
cog (0.16.1-1) unstable; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Tue, 18 Oct 2022 15:23:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Priority: optional
 Maintainer: Alberto Garcia <berto@igalia.com>
 Build-Depends: debhelper-compat (= 13),
-               cmake,
                libcairo-dev,
                libdrm-dev,
                libgbm-dev,
                libinput-dev,
+               libmanette-0.2-dev [linux-any],
                libwayland-dev,
                libwpebackend-fdo-1.0-dev (>= 1.10.0),
                libwpewebkit-1.1-dev,
+               meson,
                wayland-protocols
 Standards-Version: 4.6.1.0
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## cog 0.18.0

=== debian/changelog ===
cog (0.18.0-1) experimental; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Sun, 21 May 2023 18:57:37 +0200

cog (0.17.1-1) experimental; urgency=medium

  * New upstream development release.
  * debian/copyright:
    - Update copyright years.
  * debian/control:
    - Use libwpewebkit-2.0-dev instead of 1.1.
    - Update Standards-Version to 4.6.2.

 -- Alberto Garcia <berto@igalia.com>  Wed, 15 Mar 2023 14:57:52 +0100

=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
                libmanette-0.2-dev [linux-any],
                libwayland-dev,
                libwpebackend-fdo-1.0-dev (>= 1.10.0),
-               libwpewebkit-1.1-dev,
+               libwpewebkit-2.0-dev,
                meson,
                wayland-protocols
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/Igalia/cog
 Vcs-Browser: https://salsa.debian.org/berto/cog

## cog 0.18.4

=== meson_options.txt ===
--- 
+++ 
@@ -17,10 +17,11 @@
     description: 'build and install programs (cog, cogctl)'
 )
 option(
-    'soup2',
-    type: 'feature',
+    'wpe_api',
+    type: 'combo',
     value: 'auto',
-    description: 'Build with libsoup2 instead of libsoup3'
+    choices: ['auto', '1.0', '1.1', '2.0'],
+    description: 'WPE WebKit API to target (1.0 = soup2, 1.1/2.0 = soup3)'
 )
 
 # Wayland platform-specific features

=== debian/changelog ===
cog (0.18.4-1) unstable; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Wed, 15 May 2024 15:24:46 +0200

cog (0.18.3-2) unstable; urgency=medium

  * debian/control:
    - Build using libwpewebkit-2.0-dev.

 -- Alberto Garcia <berto@igalia.com>  Fri, 12 Apr 2024 01:31:43 +0200

cog (0.18.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Update copyright years.
  * debian/control:
    - Require dpkg-dev 1.22.5 and wpewebkit 2.42.5-1.1.

 -- Alberto Garcia <berto@igalia.com>  Sat, 16 Mar 2024 21:58:23 +0100

cog (0.18.2-1) unstable; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Wed, 13 Dec 2023 13:14:33 +0100

cog (0.18.1-1) unstable; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Wed, 15 Nov 2023 12:20:46 +0100

cog (0.18.0-3) unstable; urgency=medium

  * debian/control:
    - Add build dependency on libepoxy-dev (Closes: #1051107).

 -- Alberto Garcia <berto@igalia.com>  Sat, 02 Sep 2023 22:30:44 +0200

cog (0.18.0-2) unstable; urgency=medium

  * debian/control:
    - Use libwpewebkit-1.1-dev again. We'll switch to 2.0 when all its
      reverse dependencies are ready.

 -- Alberto Garcia <berto@igalia.com>  Fri, 21 Jul 2023 13:37:42 +0200

## cog 0.18.5

=== meson_options.txt ===
--- 
+++ 
@@ -22,6 +22,14 @@
     value: 'auto',
     choices: ['auto', '1.0', '1.1', '2.0'],
     description: 'WPE WebKit API to target (1.0 = soup2, 1.1/2.0 = soup3)'
+)
+
+# Features supported in more than one platform
+option(
+    'libmanette',
+    type: 'feature',
+    value: 'auto',
+    description: 'Use libmanette to support gamepads'
 )
 
 # Wayland platform-specific features

=== debian/changelog ===
cog (0.18.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Update copyright years.

 -- Alberto Garcia <berto@igalia.com>  Fri, 30 May 2025 10:26:13 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: web
 Priority: optional
 Maintainer: Alberto Garcia <berto@igalia.com>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                libcairo-dev,
                libdrm-dev,
+               libepoxy-dev,
                libgbm-dev,
                libinput-dev,
                libmanette-0.2-dev [linux-any],
